// L1 Data fitting example with integer constraint on the intercept

// Generate data

n = 40;
//n  =5000.
t = (0:n-1)';
y = 3.5 -.2*t;
[pp,qq]=size(y);
y = y + 0.5*rand(pp,qq,'normal');

m = [ones(n,1),t(:)];
a = [m,-m,speye(n,n)];
f = -[sum(m,'rows'),sum(-m,'rows'),2*ones(1,n)];
e = ones(n,1);

vub = [10 10, 10 10, 5*ones(1,n)];

[v,x] = lp_solve(f,a ,y,e,[],vub,[1,3]);
p = x(1:2)-x(3:4);
err = y-m*p;
maxi(abs(err))
// ans  =  1.9678359 

pause

// Now solve bigger problem

n = 200;
m = 100;
//a = sprand(m,n);
//idx = find(a<0.8);
//a(idx) = zeros(length(idx),1);
//n =2000;
//m =1000;
a = sprand (m,n,.2);
z = rand(n,1);
b = sparse(a)*z;

[v,x] = lp_solve(-ones(1,n),a,b,zeros(m,1));

plot(a*x-b);
//xtitle('Residuals');
//xlabel('Equation Number');



