function [A,b,c,lbounds,ubounds,rwstat,stavar,ranges,name] = ...
 mps2hopdm (FILMPS,bounds,maxsizes)
// READ THE MPS FILE - HOPDM

[LHS ,RHS ]=argn(0);
if RHS < 3  then
   if  RHS ==1 then
    bounds = [0;1D30]; 
   end;
   mps=readmps (FILMPS+'.mps',bounds);
else
   mps=readmps (FILMPS+'.mps',bounds,maxsizes)
end; 
//
name = mps ('name');
IROBJ = mps('irobj');
rwstat =mps('rowstat');
rhs = mps ('rhs');
M = length(rhs);
ranges = mps('ranges');
stavar = mps('stavar')
lbounds = mps ('bounds')(:,1);
ubounds = mps ('bounds')(:,2);
N =length(lbounds);

A = adj2sp(mps('colpnts'),mps('rownmbs'), mps('acoeff'));

if prod(size(A)) <> M*N then A(M,N)=0;end;
c =full(A(IROBJ,:))';
i=[1:(IROBJ-1),(IROBJ+1):M];
b=rhs(i);
A =A(i,:);
rwstat=rwstat(i);
ranges=ranges(i);




 



